<template>
    <v-layout ref="game_cont" v-resize="onResize">
        
        <div id="cont-app" style="position:relative">
            <PlayersLabels/>
            <!-- <AppLabel/>
            <Buttons :game="game"/>
            <AppWinConfirm v-model="dialog"/>
            <AppWinWinner/> -->
        </div>
        <div ref="div_game" id="div_game">
        </div>
    </v-layout>
</template>

<script>
import PlayersLabels from '../components/playersLabels';
import LoadScene from '../phaser/scenes/LoadScene';
import GameScene from '../phaser/scenes/GameScene';
import Phaser from 'phaser';

//justify-center
export default {
    mounted(){
        this.game = new Phaser.Game(this.config);
        this.game['scenes'] = [];
        //window.addEventListener('resize', this.onResize);
        //this.onResize();
    },
    data: () => ({
        config:{
            type: Phaser.CANVAS,
            width: 400, 
            height: 280,
            parent: 'div_game',
            scale: {
                mode: Phaser.Scale.NONE,
            },
            fps:{
                min:10,
                target:60,
                forceSetTimeOut:false
            },
            render:{
                powerPreference:'high-performance'
            },
            scene: [LoadScene,GameScene]
        },
        game:null,
        w:0,
        h:0,
        rot: 0
    }),
    methods:{
        send(){
            window.parent.postMessage('ифрайм говорит', '*');
        },
        onResize(){
            
            const w = document.documentElement.clientWidth;
            const h = document.documentElement.clientHeight;
            if(this.w===w && this.h===h){
                return;
            }

            this.w = w;
            this.h = h;
            //console.log('поймал ресайз');
            const size = this.$store.dispatch('game/onResize',{w:w,h:h})
            .then(size=>{
                //console.log(".then(size = ", size);
                //this.$refs.game_cont.style.minWidth = `${size.w}px`;
                //this.$refs.game_cont.style.minHeight = `${size.h}px`;
                if("rot" in size){
                    this.rot = 90;
                    //this.$emit('rotate',this.rot);
                    /*this.$refs.game_cont.style.minWidth = `${size.h}px`;
                    this.$refs.game_cont.style.minHeight = `${size.w}px`;*/
                    //this.$refs.game_cont.style.width = `${size.h/2}px`;
                    //this.$refs.game_cont.style.height = `${size.w/2}px`;
                    this.$refs.game_cont.style.transform = `rotate(${this.rot}deg)`;
                }else{
                    if(this.rot===90){
                        this.rot = 0;
                        //this.$emit('rotate',this.rot);
                        this.$refs.game_cont.style.transform = `rotate(${this.rot}deg)`;
                    }
                }
            })
            .catch(error=>{
                //console.log("error = ", error);
            });
            //console.log("size = ", size);
            
        }
    },
    components:{
        PlayersLabels
    }
};
</script>
